#include <msp430.h>
#include <string.h>
#include "si5351.h"
#include "TI_USCI_I2C_master.h"


#ifndef TIMER0_A1_VECTOR
#define TIMER0_A1_VECTOR TIMERA1_VECTOR
#define TIMER0_A0_VECTOR TIMERA0_VECTOR
#endif


#define FREQ_DEFAULT    14000000

#define FREQ_80     0
#define FREQ_40     1
#define FREQ_20     2

#define READ_BUFFER_SIZE 20                     //     

#define KEY_1           'V'                     // 4      
#define KEY_2           'Z'

#define TICKS_PER_SECOND    20
#define QUARTZ_PERIOD           0x7FFF

unsigned long counter = 0;

int freq_offset = 0;
int freq_offset1 = 0;

unsigned int diapason = FREQ_20;
unsigned long freq[3] = {3500000, 7000000, 14000000};

static int flag = 0;


unsigned char readBuffer[READ_BUFFER_SIZE];     //    UART 
unsigned int readBufferCount = 0;               //   

unsigned char key_passed = 0;
unsigned char message_len = 0;

unsigned char KEY_1_PRESSED = 0;
unsigned char KEY_2_PRESSED = 0;
unsigned char KEY_ON_PRESSED = 0;
#define TICKS_PULT_ON   288000// 4 
unsigned long pult_life_counter = 0;
unsigned int drebezg_counter = 0;
#define DREBEZG_LOOPS   4   // :         
/*
 * p1.5 led
 * p1.3 key1
 * p1.4 key2
 * p1.0 key on
 * p1.2 ctl vcc
 * */
\

#define dv  0.0032258


/*     */
float volts=0.0;
unsigned long delay_chek_ON_key = 60;
unsigned long delay_chek_ON_key_PRESSED = 4;
unsigned long delay_chek_ON_key_NO_PRESSED = 60;
unsigned long time_chek_ON_key = 0;
unsigned char KEY_ON_PRESSED_FIRST = 0;
unsigned long delay_long_pressed = 100;
unsigned long delay_short_pressed = 1;
unsigned long time_KEY_ON_START_PRESSED = 0;
unsigned char KEY_ON_PRESSED_LONG = 0;
unsigned char KEY_ON_PRESSED_SHORT = 0;

unsigned char flag_freqORcontur = 0; //0 -    , 1 -  
unsigned long delay_switching_flag_freqORcontur = 30; //    ,  
unsigned long time_switching_flag_freqORcontur = 0;// ,         
unsigned long delay_led_togle = 15;
unsigned long time_led_togle = 0;

int contur_offset = 32000;//32000 ... 32063
unsigned char CTLpultORlocal = 1; //1 -    0 -   

int local_freq_offset;

#define IN_AD0_KEY_ON       BIT0                // P1.0
#define OUT_CTL_PWR         BIT2                // P1.2
#define IN_KEY_1            BIT3                // P1.3
#define IN_KEY_2            BIT4                // P1.4
#define OUT_LED             BIT5                // P1.5

/*     */
void ADC_init(void);
void ADC_measurement(void);
void RX_ctl(void);
void RX_pwr_off(void);
void chek_ON_key(void);
void PortsSetup(void);
void ClockSetup(void);
void TimerSetup(void);
void DrawFreq(void);
void DrawIncrement(void);
void FreqInc(void);
void UpdateFreq(void);
void DrawFreq(void);
void ChangeDiap(void);
void UARTSetup(void);
void putcc(unsigned char);
void UpdateContur(void);

/*
 * main.c
 */
int main(void) {
    WDTCTL = WDTPW | WDTHOLD;   // Stop watchdog timer

    PortsSetup();
    ClockSetup();
    TimerSetup();
    UARTSetup();
    ADC_init();

    TI_USCI_I2C_setprescale(32);                  // I2C clock = 16E6/32 = 500 kHz
    __delay_cycles(100);

    //wait for the vfo to power up before
    //initializing
    //returns 1 if not powered up
    while (vfo_GetInitStatus())
    {
        __delay_cycles(100);
    }

    if (!vfo_GetInitStatus())
        vfo_init();         //si5351            -temporarily disable

    __delay_cycles(500);

    //set the initial frequency
    UpdateFreq();
    //vfo_SetChannel0Frequency(freq[diapason]/2);

    freq_offset = 32030;
    UpdateContur();

    //putcc('X');

    time_chek_ON_key = counter;
    while(1)
    {
        //_bis_SR_register(LPM3_bits + GIE);
        __bis_SR_register(/*CPUOFF + */GIE);
    }
}
void RX_ctl(void){
    chek_ON_key();
    if (KEY_ON_PRESSED_LONG == 1){
                KEY_ON_PRESSED_LONG = 0;
                RX_pwr_off();
            }
            if (KEY_ON_PRESSED_SHORT == 1){
                KEY_ON_PRESSED_SHORT = 0;
                if (flag_freqORcontur == 1 & (counter - delay_switching_flag_freqORcontur) > time_switching_flag_freqORcontur & counter > 40){
                    time_switching_flag_freqORcontur = counter;
                    flag_freqORcontur = 0; // 
                    P1OUT |= OUT_LED; // 
                }
                if (flag_freqORcontur == 0 & (counter - delay_switching_flag_freqORcontur) > time_switching_flag_freqORcontur & counter > 40){
                    time_switching_flag_freqORcontur = counter;
                    flag_freqORcontur = 1;// 
                }
            }

            if (flag_freqORcontur == 1){//        
                if ((counter - delay_led_togle) > time_led_togle ){
                    time_led_togle = counter;
                    P1OUT  ^=  OUT_LED;
                }
            }
}

void RX_pwr_off(void){
    int i;
    for(i = 0; i<20; i++){
        P1OUT &= ~ OUT_LED; // 
        __delay_cycles(500000);
        P1OUT |= OUT_LED; // 
        __delay_cycles(500000);
    }
    P1OUT  ^= OUT_CTL_PWR; //  
}

void chek_ON_key(void){
    if ((counter - delay_chek_ON_key) > time_chek_ON_key & counter > 60){//,           
        time_chek_ON_key = counter;
        ADC_measurement();
        if (volts > 3){///2.885   3,335 
            delay_chek_ON_key = delay_chek_ON_key_PRESSED;
            KEY_ON_PRESSED = 1;
            if (KEY_ON_PRESSED_FIRST == 0){
                KEY_ON_PRESSED_FIRST = 1;
                time_KEY_ON_START_PRESSED = counter;
            }
        }
        else {
            delay_chek_ON_key = delay_chek_ON_key_NO_PRESSED;
            KEY_ON_PRESSED = 0;
            KEY_ON_PRESSED_FIRST = 0;
        }
        if (KEY_ON_PRESSED_FIRST == 1 & (counter - delay_short_pressed) > time_KEY_ON_START_PRESSED){
           KEY_ON_PRESSED_SHORT = 1;
        }
        if (KEY_ON_PRESSED_FIRST == 1 & (counter - delay_long_pressed) > time_KEY_ON_START_PRESSED){
            KEY_ON_PRESSED_SHORT = 0;
            KEY_ON_PRESSED_LONG = 1;
           KEY_ON_PRESSED_FIRST = 0;
        }

    }

}

void ADC_measurement(void){
    ADC10CTL0 |= ADC10SC;   //   
    while ((ADC10CTL1 & ADC10BUSY) == 0x01); // ,   
    volts=ADC10MEM*dv;  //      
}


void ADC_init(void) {
            //  Vcc/Vss( )  / ,
            // 16 x ADC10CLKs (  16 ),  .
    ADC10CTL0 = SREF_0 + ADC10SHT_2 + ADC10ON;
            //  A0,  ADC10CLK  1,  .
    ADC10CTL1 =  INCH_0 + SHS_0 + ADC10SSEL_0 + ADC10DIV_0 + CONSEQ_0;
    ADC10AE0 = IN_AD0_KEY_ON;      //      P1.0

    ADC10CTL0 |= ENC;     //  .
} // ADC_init


void ClockSetup(void)
{
    BCSCTL1 = CALBC1_16MHZ;     //    Basic Clock System.
    DCOCTL = CALDCO_16MHZ;      //  
                                //  Digital Controlled Oscillator.
    BCSCTL3 |= LFXT1S_0;        // LFXT1 = XT1
    while(IFG1 & OFIFG)         // wait for OSCFault to clear
    {
      IFG1 &= ~OFIFG;
      _delay_cycles(10);
    }
    BCSCTL2 |= SELM_0;      // MCLK = DCO, SMCLK = DCO
}

void PortsSetup(void)
{
    P2DIR |= 63;                // P2 -    (P2.0...P2.5)
    P2OUT &= ~(63);

    P1DIR |= OUT_LED + OUT_CTL_PWR;  //
    P1OUT |= OUT_LED; // 
    __delay_cycles(500000);
    P1OUT &= ~ OUT_LED; // 
    __delay_cycles(500000);
    P1OUT |= OUT_LED; // 
    __delay_cycles(100000);
    P1OUT &= ~ OUT_LED; // 
    __delay_cycles(100000);
    P1OUT |= OUT_LED; // 

    P1OUT |= OUT_CTL_PWR; //  
    //P1OUT &= ~ OUT_CTL_PWR; //  , ..     


    P1DIR &= ~( IN_KEY_1 + IN_KEY_2  );     //  - 
    P1REN |=  IN_KEY_1 + IN_KEY_2;        //  
    P1OUT |=   IN_KEY_1 + IN_KEY_1 ;        //   
    P1IES |=   IN_KEY_1 + IN_KEY_2;        //     1  0
    P1IFG &= ~(  IN_KEY_1 + IN_KEY_2);     //  
    P1IE |=  IN_KEY_1 + IN_KEY_2;         //  


}

void TimerSetup(void)
{
    //  1
    TA1CCR0 = QUARTZ_PERIOD / TICKS_PER_SECOND;     //  1 -  
    TA1CTL = TASSEL_1 + MC_1;                       // ACLK - 32768   

    TA1CCTL0 = CCIE;
}

void UARTSetup()
{
    P1SEL |= BIT1 ;   //   P1.1  RXD  UART, P1.2  TXD
    P1SEL2 |= BIT1 ;  //

    UCA0CTL1 |= UCSWRST;    //       UART  
                            //     
                            //  (   UART).
    UCA0CTL1 |= UCSSEL_1;   //  UART   
                            // AMCLK,    .
    UCA0BR0 = 0x1B;         //    AMCLK (9600 / 1200).
    UCA0BR1 = 0x00;
    //UCA0BR0 = 0x68;       //    SMCLK (1000000 / 9600).
    //UCA0BR1 = 0x00;
    //UCA0BR0 = 0x80;       //    SMCLK (16000000 / 9600).
    //UCA0BR1 = 0x06;
    UCA0MCTL = 0x02;        //   .
                            //    .
    UCA0CTL1 &= ~UCSWRST;   //  UART .

    IE2 |= UCA0RXIE;      //    
}

void UpdateFreq()
{
    if(CTLpultORlocal == 1){
        freq[diapason] = FREQ_DEFAULT + (long)freq_offset*100;
        if (flag == 1)
            return;
        flag = 1;
        vfo_SetChannel0Frequency(freq[diapason]/2);
        flag = 0;
        local_freq_offset = freq_offset;
    }
    else
    {
        freq[diapason] = FREQ_DEFAULT + (long)local_freq_offset*100;
        if (flag == 1)
            return;
        flag = 1;
        vfo_SetChannel0Frequency(freq[diapason]/2);
        flag = 0;
    }

}

void UpdateContur()
{
    if(CTLpultORlocal == 1){
        P2OUT = (unsigned char)(freq_offset - 32000);
        contur_offset = freq_offset;
    }
    else
        P2OUT = (unsigned char)(contur_offset - 32000);
}

void ProcessMessage(void)
{
    pult_life_counter = 0;//    

    freq_offset = (unsigned char)readBuffer[3];
    freq_offset +=  (unsigned int)readBuffer[4] << 8;
    freq_offset1 = (unsigned char)readBuffer[5];
    freq_offset1 +=  (unsigned int)readBuffer[6] << 8;

    CTLpultORlocal = 1;

    if (freq_offset1 == freq_offset)
    {
        if (freq_offset >= 32000){ //32000 ... 32063
            UpdateContur();
        }
        else
            UpdateFreq();
    }
}

void ProcessRead(void)
{
    if (key_passed == 2)
    {
        if (message_len == 0)
        {
            message_len = readBuffer[readBufferCount++];
            if (message_len == 0)                   //  ,  
            {
                key_passed = 0;
                readBufferCount = 0;
            }
        }
        else
        {
            if (readBufferCount < message_len + 2)
            {
                readBufferCount++;
            }
            else
            {
                readBufferCount = 0;                //  ,    
                key_passed = 0;
                ProcessMessage();                   //  
            }
        }
    }
    else if (key_passed == 0 && readBuffer[readBufferCount] == KEY_1)
    {
        key_passed = 1;
        readBufferCount++;
    }
    else if (key_passed == 1)
    {
        if (readBuffer[readBufferCount] == KEY_2)
        {
            key_passed = 2;
            readBufferCount++;
        }
        else
        {
            key_passed = 0;
            readBufferCount = 0;
        }
    }
}

void putcc(unsigned char c)
{
    while (!(IFG2 & UCA0TXIFG));    // Poll TXIFG to until set
    UCA0TXBUF = c;                  // TX -> character
}


//=========================================================================
// ISR
//
// Timer 0 interrupt - 20   
#pragma vector=TIMER1_A0_VECTOR
__interrupt void Timer_A (void)
{
    counter++;

    RX_ctl();

    if (drebezg_counter < DREBEZG_LOOPS)
           drebezg_counter++;


    if (pult_life_counter < TICKS_PULT_ON)
        pult_life_counter++;
    else
        RX_pwr_off(); //  , ..        



}


#pragma vector = USCIAB0RX_VECTOR
__interrupt void USCIAB0RX_ISR(void)
{
    if (UCB0STAT & UCNACKIFG)            // send STOP if slave sends NACK
    {
        UCB0CTL1 |= UCTXSTP;
        UCB0STAT &= ~UCNACKIFG;
    };

    if (IFG2 & UCA0RXIFG)                // Read byte from UART
    {
        IFG2 &= ~UCA0RXIFG;
        readBuffer[readBufferCount] = UCA0RXBUF;
        ProcessRead();
        _bis_SR_register(GIE);
    }
}


// P1 interrupt
#pragma vector = PORT1_VECTOR
__interrupt void P2_ISR(void)
{
    KEY_1_PRESSED = 0;
    KEY_2_PRESSED = 0;
    switch(P1IFG & (IN_KEY_1 + IN_KEY_2))
    {
        case IN_KEY_1:
            P1IFG &= ~IN_KEY_1;
            if (drebezg_counter < DREBEZG_LOOPS)
                return;
            drebezg_counter = 0;
            KEY_1_PRESSED = 1;
            pult_life_counter = 0;//    
            CTLpultORlocal = 0;
            if (flag_freqORcontur == 0){
                if (local_freq_offset < 2100){//14210 kHz MAX
                    local_freq_offset = local_freq_offset + 10;
                    UpdateFreq();
                }
                else{
                    int i;
                    for(i = 0; i<5; i++){
                        P1OUT &= ~ OUT_LED; // 
                        __delay_cycles(200000);
                        P1OUT |= OUT_LED; // 
                        __delay_cycles(200000);
                    }
                }
            }
            else{
                if (contur_offset <= 32060)
                    contur_offset=contur_offset + 3;
                UpdateContur();
            }
            return;
        case IN_KEY_2:
            P1IFG &= ~IN_KEY_2;
            if (drebezg_counter < DREBEZG_LOOPS)
                return;
            KEY_2_PRESSED = 1;
            drebezg_counter = 0;
            pult_life_counter = 0;//    
            CTLpultORlocal = 0;
            if (flag_freqORcontur == 0){
                if (local_freq_offset > -10){//13990 kHz MIN
                    local_freq_offset = local_freq_offset - 10;
                    UpdateFreq();
                }
                else
                {
                    int i;
                    for(i = 0; i<5; i++){
                        P1OUT &= ~ OUT_LED; // 
                        __delay_cycles(200000);
                        P1OUT |= OUT_LED; // 
                        __delay_cycles(200000);
                    }
                }
            }
            else{
                if (contur_offset >= 32002)
                    contur_offset = contur_offset - 3;
                UpdateContur();
            }
            return;
        default:
            P1IFG = 0;
            return;
    }
} // P2_ISR

